﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Numerics;
using System.Windows.Forms;
using System.Drawing;

namespace CatShooting
{
    class Ball
    {
        enum State
        {
            Move,
            Hit,
            Destroy
        };

        State state = State.Move;
        protected Image img;
        protected int speed = 0;

        public Vector2 pos;
        public Vector2 size;
        public bool willDestroy = false;

        public Ball()
        {
            this.pos = new Vector2(0, 0);
            this.size = new Vector2(100, 100);

            Random r = new System.Random();
            this.speed = r.Next(3, 9);

            this.img = Image.FromFile(@"./ball.png");
        }

        public virtual void Hit()
        {
            this.state = State.Hit;
        }

        public void Update()
        {
            if (this.state == State.Move)
            {
                this.pos.X -= this.speed;
                if (this.pos.X < 0)
                {
                    this.willDestroy = true;
                }
            }
            else if (this.state == State.Hit)
            {
                this.pos.X -= this.speed;
                this.size.X -= 15;
                this.size.Y -= 15;

                if (this.size.X <= 0)
                {
                    this.state = State.Destroy;
                    this.willDestroy = true;
                }
            }
        }

        public void Draw(PaintEventArgs e)
        {
            e.Graphics.DrawImage(this.img, this.pos.X - this.size.X / 2, this.pos.Y - this.size.Y / 2, this.size.X, this.size.Y);
        }
    }
}
