﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Drawing;
using System.Windows.Forms;
using System.Numerics;

namespace CatShooting
{
    class Ship
    {
        enum State
        {
            Move,
            Stop,
        };

        State state = State.Move;

        Image img, damagedImg;
        public Vector2 pos;
        public Vector2 size;
        Timer timer;

        public Ship()
        {
            this.img = Image.FromFile(@"./ship.png");
            this.damagedImg = Image.FromFile(@"./damagedShip.png");

            this.pos = new Vector2(100, 100);
            this.size = new Vector2(220, 220);

        }

        public void Draw(PaintEventArgs e)
        {
            Image i = (state == State.Move) ? img : damagedImg;
            e.Graphics.DrawImage(i, this.pos.X - this.size.X / 2, this.pos.Y - this.size.Y / 2, this.size.X, this.size.Y);
        }

        public void Update(int mousePosY)
        {
            if (this.state == State.Move)
            {
                this.pos.Y = mousePosY;
            }
        }

        void Restart(object sender, EventArgs e)
        {
            this.timer.Stop();
            this.state = State.Move;
        }

        public void Stop()
        {
            if (this.state != State.Move) return;

            this.state = State.Stop;

            this.timer = new Timer();
            this.timer.Interval = 3000;
            this.timer.Tick += new EventHandler(Restart);
            this.timer.Start();
        }
    }
}

